/*******************************************************************************
	Copyright (C) 2013 John Chapman

	This software is distributed freely under the terms of the MIT License.
	See "license.txt" or "http://copyfree.org/licenses/mit/license.txt".
*******************************************************************************/
#version 130

uniform sampler2D uInputTex;
uniform sampler2D uLensFlareTex;
uniform sampler2D uLensDirtTex;
uniform sampler2D uLensStarTex;

uniform mat4 uLensStarMatrix; // camera rotation metric for starburst

in vec2 vTexcoord;
out vec4 fResult;

/*----------------------------------------------------------------------------*/
void main() {
	vec4 lensMod = texture(uLensDirtTex, vTexcoord);
	vec2 lensStarTexcoord = (uLensStarMatrix * vec4(vTexcoord, 1.0,1.0)).xy;
	lensMod += texture(uLensStarTex, lensStarTexcoord);

	vec4 result = texture(uInputTex, vTexcoord);

	result += texture(uLensFlareTex, vTexcoord) * lensMod;

	fResult = result;
}