#version 120

uniform float     uAttenuation;
uniform vec3    uLightPosition;
uniform vec4    uColor;
uniform float     uLightFarClipDistance;
uniform sampler2D uDepthMap;
uniform sampler2D uCookieMap;
uniform sampler2D uNoiseMap;
uniform float Time;

varying vec3 vPosition_;
varying vec4 vUV;

void main()
{
	vec4 iUV = vUV / vUV.w;
	float Depth  = texture2D(uDepthMap, iUV.xy).r;
	
    if (Depth < clamp( length(vPosition_-uLightPosition) / uLightFarClipDistance,0.0,1.0 ))
	{
		gl_FragColor = vec4(0,0,0,1);
		gl_FragColor = gl_FragColor * uColor;
	}
	else
	{
		vec4 Cookie = texture2D(uCookieMap, iUV.xy);
        float t = Time * 0.0225;
		vec2 Noise = vec2(	texture2D(uNoiseMap, iUV.xy - t).r,
							texture2D(uNoiseMap, iUV.xy - t).g);
		
		float noise = Noise.x * Noise.y;
        float length_ = length(vPosition_-uLightPosition)/uLightFarClipDistance;
        float atten  = 0.25 + 1/(length_*length_);
		
		gl_FragColor = vec4(Cookie.rgb * Cookie.a * atten * uAttenuation * noise , 1);
		gl_FragColor = gl_FragColor * uColor;
	}
}
